#!/usr/bin/env bash
tmpname=$1
print_header () {
cat <<EOF
%!PS-Adobe-3.0 EPSF-3.0
%%Creator: Jon Emil Jahren
%%BoundingBox: 0 0 472 500
%%LanguageLevel: 2
%%Pages: 1
%%DocumentData: Clean7Bit
/lw
0.2
def
/sr {
	2
	lw
	add
	0
	translate
}def
/cdiamond0 {
	newpath
	0 0 moveto
	1 1 rlineto
	1 -1 rlineto
	-1 -1 rlineto
	-1 1 rlineto
	closepath
	setrgbcolor
	lw
	setlinewidth
	stroke
} def
	
/cdiamond1 {
	newpath
	0 0 moveto
	1 1 rlineto
	1 -1 rlineto
	-1 -1 rlineto
	-1 1 rlineto
	closepath
	setrgbcolor
	gsave
	fill
	grestore
	lw
	setlinewidth
	stroke
} def

gsave
3 3 scale
/Times-Roman findfont
3 scalefont
setfont

5 155 translate
gsave
0 6 translate
gsave
1 0 0 cdiamond0
grestore
newpath
5 -1 moveto
(FPGA driven 0) show
grestore

gsave
0 3 translate
gsave
1 0 0 cdiamond1
grestore
newpath
5 -1 moveto
(FPGA driven 1) show
grestore

gsave
30 6 translate
gsave
0 0 1 cdiamond0
grestore
newpath
5 -1 moveto
(External driven 0) show
grestore

gsave
30 3 translate
gsave
0 0 1 cdiamond1
grestore
newpath
5 -1 moveto
(External driven 1) show
grestore

gsave
newpath
0 -1 moveto
(high) show
newpath
140 -1 moveto
(low) show
grestore
EOF
}

lasttest=0
n=0
m=0
fname=$tmpname"_s-"$m".eps"
print_header > "$fname"
while read line ; do
	((n=n+1))
	fpga_pins=""
	ext_pins=""
	if [ "$lasttest" -eq 1 ] ; then
		((m=m+1))
		fname=$tmpname"_s-"$m".eps"
		print_header > "$fname"
		lasttest=0
	fi

	echo "0 -3 translate" >> "$fname"
	echo "newpath" >> "$fname"
	echo "-3 -1 moveto" >> "$fname"
	echo "($n) show" >> "$fname"
	echo "gsave" >> "$fname"
	for i in `seq 0 63` ; do
		pin=${line:$((i*2)):2}
		mode=${pin:1:1} #bits are written reversed now, from high to low, change mode and val if needed.
		val=${pin:0:1} #remember to also change ca_state.c correspndingly if needed
		if [ "$mode" -eq 0 ] ; then
			fpga_pins=$fpga_pins$pin
		elif [ "$mode" -eq 1 ] ; then
			ext_pins=$ext_pins$pin
		fi
	done
	line=$fpga_pins$ext_pins
	for i in `seq 0 63` ; do
		echo "sr" >> "$fname"
		pin=${line:$((i*2)):2}
		mode=${pin:1:1}
		val=${pin:0:1}
		if [ "$mode" -eq 0 ] ; then
			echo "1 0 0" >> "$fname" #red colour
		elif [ "$mode" -eq 1 ] ; then
			echo "0 0 1" >> "$fname" #blue colour
		else
			echo "somethingwrong" >> "$fname" #should break the ps
		fi
		echo "cdiamond$val" >> "$fname"
	done
	echo "grestore" >> "$fname"
	((modulo=n%50))
	if [ "$modulo" -eq 0 ] ; then
		echo -e "grestore\n%%EOF" >> "$fname" #close last file
		lasttest=1
		epstopdf "$fname"
	fi
done
if [ "$modulo" -ne 0 ] ; then
	echo -e "grestore\n%%EOF" >> "$fname" #close last file
	epstopdf "$fname"
fi

