--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   18:20:31 02/06/2012
-- Design Name:   
-- Module Name:   /home/jonemil/projects/materio/src/fpga_code/ca_cpu_test.vhd
-- Project Name:  EMB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: ca_cpu
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.cpu_package.all;
 
ENTITY ca_cpu_test IS
END ca_cpu_test;
 
ARCHITECTURE behavior OF ca_cpu_test IS --type instances

signal mem_w_address_array : mem_w_address_a(0 to N_CORES - 1);
signal mem_w_data_array : mem_w_data_a(0 to N_CORES - 1);
signal mem_w_enable_array : mem_w_enable_a(0 to N_CORES - 1);
signal mem_w_out_array : mem_w_out_a(0 to N_CORES - 1);

	--Inputs
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';
   signal core_rst : std_logic := '0';

   signal conf_reg_i : std_logic_vector(127 downto 0) := (1 => '1', 3 => '0', others => '0');

 	--Outputs
   signal conf_reg_o : std_logic_vector(127 downto 0);
   signal done_o : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
	
type inst_t is array(0 to 3) of std_logic_vector(15 downto 0);
signal instructions : inst_t := (OPC_IN&"000000"&OPC_IN&"000000",
											OPC_IN&"000000" & OPC_ALU&ALU_FUNC_XOR,
											OPC_ALU&ALU_FUNC_XOR & OPC_IN&"000001",
											OPC_OUT&"000000" & OPC_ALU&ALU_FUNC_OR);
signal instructions2 : inst_t := (OPC_IN&"000000"&OPC_IN&"000000",
											OPC_IN&"000000" & OPC_ALU&ALU_FUNC_XOR,
											OPC_ALU&ALU_FUNC_XOR & OPC_IN&"000001",
											OPC_OUT&"000000" & OPC_ALU&ALU_FUNC_OR);											
BEGIN
 conf_reg_o(127 downto 4) <= (127 downto 4 => '0');
	-- Instantiate the Unit Under Test (UUT)
   uut: ca_cpu PORT MAP (
          clk => clk,
          rst => rst,
          core_rst => core_rst,
          mem_w_address_array => mem_w_address_array,
          mem_w_data_array => mem_w_data_array,
          mem_w_enable_array => mem_w_enable_array,
          mem_w_out_array => mem_w_out_array,
          conf_reg_i => conf_reg_i,
          conf_reg_o => conf_reg_o,
          done_o => done_o
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
		core_rst <= '0';
		wait until rising_edge(clk);
		for i in 0 to 3 loop
			mem_w_enable_array(0) <= '1';
			mem_w_data_array(0) <= instructions(i);
			mem_w_address_array(0) <= std_logic_vector(to_unsigned(i, 4));
			wait until rising_edge(clk);
		end loop;
		for i in 0 to 3 loop
			mem_w_enable_array(1) <= '1';
			mem_w_data_array(1) <= instructions2(i);
			mem_w_address_array(1) <= std_logic_vector(to_unsigned(i, 4));
			wait until rising_edge(clk);
		end loop;

		core_rst <= '1';
		wait until rising_edge(clk);

      wait until done_o = '1';
		wait;
   end process;

END;
