----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:56:12 02/15/2012 
-- Design Name: 
-- Module Name:    ca_mem - ca_mem_arch 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
use work.emb.all;
use work.cpu_package.all;

entity ca_mem is
	port (
		clk : in std_logic;
		
		-- port A write/read
		a_we : in std_logic;
		a_addr : in std_logic_vector(MEM_CAADDR_BITS - 1 downto 0);
		a_data_i : in std_logic_vector(MEM_DATA_BITS - 1 downto 0);
		a_data_o : out std_logic_vector(MEM_DATA_BITS - 1 downto 0);
		
		--port B read
		b_addr : in std_logic_vector(MEM_CAADDR_BITS - 1 downto 0);
		--b_data_i : in std_logic_vector(MEM_DATA_BITS - 1 downto 0);
		b_data_o : out std_logic_vector(MEM_DATA_BITS - 1 downto 0)
	);
end ca_mem;

architecture ca_mem_arch of ca_mem is
type ram_t is array (2 ** MEM_CAADDR_BITS - 1 downto 0) of std_logic_vector(15 downto 0);
signal ram : ram_t := (others => (others => '0'));
begin
process(clk)
begin
	if rising_edge(clk) then
		if a_we = '1' then
			ram(to_integer(unsigned(a_addr))) <= a_data_i;
			a_data_o <= a_data_i;
		end if;
		a_data_o <= ram(to_integer(unsigned(a_addr)));
		b_data_o <= ram(to_integer(unsigned(b_addr)));
	end if;
end process;

end ca_mem_arch;

