----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:49:11 02/10/2012 
-- Design Name: 
-- Module Name:    config_mem - config_mem_arch 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
use work.emb.all;

entity config_mem is
	port(
				clk : in std_logic;
				-- port A read/write
	         a_we  : in std_logic;
            a_addr: in std_logic_vector(MEM_SUBADDR_BITS - 1 downto 0);
            a_din : in std_logic_vector(MEM_DATA_BITS - 1 downto 0);
            a_do  : out std_logic_vector(MEM_DATA_BITS - 1 downto 0);
				
				-- port B read/write
				b_we  : in std_logic;
            b_addr: in std_logic_vector(MEM_SUBADDR_BITS - 1 downto 0);
            b_din : in std_logic_vector(MEM_DATA_BITS - 1 downto 0);
            b_do  : out std_logic_vector(MEM_DATA_BITS - 1 downto 0)
	);
end config_mem;

architecture config_mem_arch of config_mem is
    type ram_t is array (1023 downto 0) of std_logic_vector(15 downto 0);
    shared variable ram : ram_t := (OTHERS => (OTHERS => '0'));
begin
-- port a
process (clk)
begin
	if rising_edge(clk) then
	if a_we = '1' then
		ram(to_integer(unsigned(a_addr))) := a_din;
		a_do <= a_din;
	else
		a_do <= ram(to_integer(unsigned(a_addr)));
	end if;
	end if;
end process;

-- port b
process (clk)
begin
	if rising_edge(clk) then
	if b_we = '1' then
		ram(to_integer(unsigned(b_addr))) := b_din;
		b_do <= b_din;
	else
		b_do <= ram(to_integer(unsigned(b_addr)));
	end if;
	end if;
end process;
end config_mem_arch;

