--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   21:41:17 11/08/2011
-- Design Name:   
-- Module Name:   /home/jon/projects/cpu/src/cpu/cpu_test.vhd
-- Project Name:  cpu
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: cpu
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.cpu_package.all;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY cpu_test IS
END cpu_test;
 
ARCHITECTURE behavior OF cpu_test IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT cpu
    PORT(
         clk : IN  std_logic;
         rst : IN  std_logic;
         mem_w_address_i : IN  std_logic_vector(3 downto 0);
         mem_w_data_i : IN  std_logic_vector(15 downto 0);
         mem_w_enable_i : IN  std_logic;
         mem_w_out_o : OUT  std_logic_vector(15 downto 0);
         conf_reg : IN  std_logic_vector(127 downto 0);
         cpu_out : OUT  std_logic_vector(0 downto 0);
         cpu_stop : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';
   signal mem_w_address_i : std_logic_vector(3 downto 0) := (others => '0');
   signal mem_w_data_i : std_logic_vector(15 downto 0) := (others => '0');
   signal mem_w_enable_i : std_logic := '0';
   signal conf_reg : std_logic_vector(127 downto 0) := (0 => '1', 4 => '1', others => '0');

 	--Outputs
   signal mem_w_out_o : std_logic_vector(15 downto 0);
   signal cpu_out : std_logic_vector(0 downto 0);
   signal cpu_stop : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
	type inst_t is array(0 to 3) of std_logic_vector(15 downto 0);
	--signal instructions : inst_t := (OPC_IN&"000001"&OPC_IN&"000000",OPC_OUT&"000000"&OPC_IN&"000010" );
	--signal instructions : inst_t := ("10"&"000001"&"01"&"000000","11"&"000011"&"11"&"000010" );
	--signal instructions : inst_t := (OPC_IN&"000001"&OPC_IN&"000000",OPC_OUT&"000000"&OPC_IN&"000000","0000000000000000");
	--signal instructions : inst_t := (OPC_IN&"000000"&OPC_IN&"000001",OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR,"0000000000000000");
signal instructions : inst_t := (OPC_IN&"000000"&OPC_IN&"000000",
											OPC_IN&"000000" & OPC_ALU&ALU_FUNC_XOR,
											OPC_ALU&ALU_FUNC_XOR & OPC_IN&"000001",
											OPC_OUT&"000000" & OPC_ALU&ALU_FUNC_OR);
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: cpu PORT MAP (
          clk => clk,
          rst => rst,
          mem_w_address_i => mem_w_address_i,
          mem_w_data_i => mem_w_data_i,
          mem_w_enable_i => mem_w_enable_i,
          mem_w_out_o => mem_w_out_o,
          conf_reg => conf_reg,
          cpu_out => cpu_out,
          cpu_stop => cpu_stop
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
		rst <= '0';
		wait until rising_edge(clk);
		for i in 0 to 3 loop
			mem_w_enable_i <= '1';
			mem_w_data_i <= instructions(i);
			mem_w_address_i <= std_logic_vector(to_unsigned(i, 4));
			wait until rising_edge(clk);
		end loop;
		mem_w_enable_i <= '0';
		for i in 0 to 3 loop
			mem_w_address_i <= std_logic_vector(to_unsigned(i, 4));
			wait until rising_edge(clk);
		end loop;
      wait for 100 ns;
		wait until rising_edge(clk);
		rst <= '1';

      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
