library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.cpu_package.all;

entity fetch is
	port	(
		clk : in std_logic;
		rst : in std_logic;
		w_enable : in std_logic;
		w_addr : in std_logic_vector(IADDR_BUS downto 0);

		-- instruction memory
		-- read port
		r_address : out std_logic_vector(IADDR_BUS downto 0);
		r_out : in std_logic_vector(IDATA_BUS - 1 downto 0);
		fetch_out : out std_logic_vector(IDATA_BUS - 1 downto 0)
		);
end fetch;

architecture fetch_arch of fetch is
signal addr_reg : std_logic_vector(IADDR_BUS downto 0);
begin
r_address <= addr_reg;
fetch_out <= r_out;

pc : process (clk, rst, addr_reg)
	begin
		if rst = '0' then
			--addr_reg <= (others => '0');
			addr_reg <= std_logic_vector(to_unsigned(0, IADDR_BUS+1));
		elsif rising_edge(clk) then
			if w_enable = '1' then
				addr_reg <= std_logic_vector(unsigned(w_addr));
			else
				addr_reg <= std_logic_vector(unsigned(addr_reg) + 1);
			end if;
		end if;
	end process;

end fetch_arch;
