library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.cpu_package.all;

entity io_reg is
	port (
		clk : in std_logic;
		rst : in std_logic;
		conf_reg : in std_logic_vector(CONF_BUS - 1 downto 0);
		conf_addr : in std_logic_vector(INADDR_BUS - 1 downto 0);
		w_enable : in std_logic;
		data_in : in std_logic_vector(DDATA_BUS - 1 downto 0);
		w_out : out std_logic;
		r_out : out std_logic);
end io_reg;

architecture io_reg_arch of io_reg is
	signal w_out_s : std_logic;
begin
process(conf_reg, conf_addr)
begin
	r_out <= conf_reg(1);
	for i in 0 to (CONF_BUS/2)-1 loop
		if i*2+1 = to_integer(unsigned(std_logic_vector'(conf_addr&"1"))) then
			r_out <= conf_reg(i*2+1);
		end if;
	end loop;
end process;
process(clk, rst)
begin
	if rst = '0' then
		w_out_s <= '0';
	elsif rising_edge(clk) then
		if w_enable = '1' then
			w_out_s <= data_in(0);
		else
			--r_out <= conf_reg(to_integer(unsigned(conf_addr&"0")));
		end if;
	end if;
end process;
w_out <= w_out_s;

end io_reg_arch;
