--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   13:03:28 02/24/2012
-- Design Name:   
-- Module Name:   C:/cygwin/home/jon/projects/materio/src/fpga_code//toplevel_test.vhd
-- Project Name:  EMB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: toplevel
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use ieee.numeric_std.all;
use work.emb.all;
use work.cpu_package.all;

ENTITY toplevel_test IS
END toplevel_test;
 
ARCHITECTURE behavior OF toplevel_test IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT toplevel
    PORT(
         main_clk : IN  std_logic;
         main_rst : IN  std_logic;
         mem_addr : IN  std_logic_vector(11 downto 0);
         mem_data : INOUT  std_logic_vector(15 downto 0);
         mem_cs : IN  std_logic;
         mem_re : IN  std_logic;
         mem_we : IN  std_logic;
         mem_wait : OUT  std_logic;
         io_port : INOUT  std_logic_vector(63 downto 0)
        );
    END COMPONENT;
    
	-- uc3 clk
	signal uc3_clk : std_logic := '0';

   --Inputs
   signal main_clk : std_logic := '0';
   signal main_rst : std_logic := '0';
   signal mem_addr : std_logic_vector(11 downto 0) := (others => '0');
   signal mem_cs : std_logic := '1';
   signal mem_re : std_logic := '1';
   signal mem_we : std_logic := '1';

	--BiDirs
   signal mem_data : std_logic_vector(15 downto 0);
	signal mem_data_be : std_logic_vector(15 downto 0); -- big endian hack
   signal io_port : std_logic_vector(63 downto 0);

 	--Outputs
   signal mem_wait : std_logic;

   -- Clock period definitions
   constant main_clk_period : time := 33.33 ns;
	constant uc3_clk_period : time := 62.5 ns;
 --constant uc3_clk_period : time := 95.5 ns;
	signal inst_done : std_logic_vector(15 downto 0) := "00000000"&OPC_OUT&"000000";
--	signal conf0 : std_logic_vector(MAT_PINS * 2 - 1 downto 0) :=
--	B"0101010101010101_0101010101010101_0101010101010101_0101010101010101_0101010101010101_0101010101010101_0101010101010101_0101010101010001";
--signal conf0 : std_logic_vector(MAT_PINS * 2 - 1 downto 0) :=
--	B"1000001000101000_1000100010100010_1000001000001000_1000001000001000_1000100000001000_0000100000101000_1010100000100010_1000000010100010";
signal conf0 : std_logic_vector(MAT_PINS * 2 - 1 downto 0) := ( others => '1') ;
	--B"1000001000101000_1000100010100010_1000001000001000_1000001000001000_1000100000001000_0000100000101000_1010100000100010_1000000010100010";
	
	type inst_t is array(0 to 3) of std_logic_vector(15 downto 0);
	signal instructions : inst_t := (OPC_IN&"000000"&OPC_IN&"000001",
											OPC_IN&"000000" & OPC_ALU&ALU_FUNC_XOR,
											OPC_ALU&ALU_FUNC_XOR & OPC_IN&"000001",
											OPC_OUT&"000000" & OPC_ALU&ALU_FUNC_OR);
--	type prg_t is array(0 to 2) of std_logic_vector(15 downto 0);	
--	signal core0_prg : prg_t := (OPC_IN&"000001"&OPC_IN&"000000",
--											OPC_IN&"011000"&OPC_ALU&ALU_FUNC_XOR,
--											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
--	signal core8_prg : prg_t := (OPC_IN&"001001"&OPC_IN&"001000",
--											OPC_IN&"000000"&OPC_ALU&ALU_FUNC_XOR,
--											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
--	signal core16_prg : prg_t := (OPC_IN&"010001"&OPC_IN&"010000",
--											OPC_IN&"001000"&OPC_ALU&ALU_FUNC_XOR,
--											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
--	signal core24_prg : prg_t := (OPC_IN&"011001"&OPC_IN&"011000",
--											OPC_IN&"010000"&OPC_ALU&ALU_FUNC_XOR,
--											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
	type prg_t is array(0 to 2) of std_logic_vector(15 downto 0);	
	signal core0_prg : prg_t := (OPC_OUT&"000001"&OPC_IN&"000000",
											OPC_IN&"011000"&OPC_ALU&ALU_FUNC_XOR,
											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
	signal core8_prg : prg_t := (OPC_OUT&"001001"&OPC_IN&"001000",
											OPC_IN&"000000"&OPC_ALU&ALU_FUNC_XOR,
											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
	signal core16_prg : prg_t := (OPC_OUT&"010001"&OPC_IN&"010000",
											OPC_IN&"001000"&OPC_ALU&ALU_FUNC_XOR,
											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);
	signal core24_prg : prg_t := (OPC_OUT&"011001"&OPC_IN&"011000",
											OPC_IN&"010000"&OPC_ALU&ALU_FUNC_XOR,
											OPC_OUT&"000000"&OPC_ALU&ALU_FUNC_XOR);

	signal test : std_logic_vector(15 downto 0) := CMD_CONF_EVO;
	signal where : string(8 downto 1) := "STARTING";
BEGIN
 
 mem_data_be(7 downto 0) <= mem_data(15 downto 8); -- big endian hack
 mem_data_be(15 downto 8) <= mem_data(7 downto 0);
 
	-- Instantiate the Unit Under Test (UUT)
   uut: toplevel PORT MAP (
          main_clk => main_clk,
          main_rst => main_rst,
          mem_addr => mem_addr,
          mem_data => mem_data_be,
          mem_cs => mem_cs,
          mem_re => mem_re,
          mem_we => mem_we,
          mem_wait => mem_wait,
          io_port => io_port
        );

   -- Clock process definitions
   main_clk_process :process
   begin
		main_clk <= '0';
		wait for main_clk_period/2;
		main_clk <= '1';
		wait for main_clk_period/2;
   end process;
 
-- uc3 clock process
	uc3 : process
	begin
		uc3_clk <= '0';
		wait for uc3_clk_period/2;
		uc3_clk <= '1';
		wait for uc3_clk_period/2;
	end process;

io_port <= (others => 'H');

   -- Stimulus process
   stim_proc: process
   begin
      -- hold reset state for 100 ns.
		mem_data <= (others => 'Z');
		main_rst <= '0';
		mem_cs <= '1';
		mem_we <= '1';
      wait for 100 ns;
		wait until rising_edge(uc3_clk);
		main_rst <= '1';
		wait until rising_edge(uc3_clk);
	--	for i in 0 to 3 loop
--			mem_addr <= std_logic_vector(unsigned(MEM_CORE0) + i);
--			wait until rising_edge(uc3_clk);
--			mem_cs <= '0';
--			wait until rising_edge(uc3_clk);
--			mem_we <= '0';
--			mem_data <= instructions(i);
--			wait until rising_edge(uc3_clk);
--			wait until rising_edge(uc3_clk);
--			mem_we <= '1';
--			wait until rising_edge(uc3_clk);
--			mem_cs <= '1';
--			wait until rising_edge(uc3_clk);
--		end loop;
--		for i in 0 to 3 loop
--			mem_addr <= std_logic_vector(unsigned(MEM_CORE1) + i);
--			wait until rising_edge(uc3_clk);
--			mem_cs <= '0';
--			wait until rising_edge(uc3_clk);
--			mem_we <= '0';
--			mem_data <= instructions(i);
--			wait until rising_edge(uc3_clk);
--			wait until rising_edge(uc3_clk);
--			mem_we <= '1';
--			wait until rising_edge(uc3_clk);
--			mem_cs <= '1';
--			wait until rising_edge(uc3_clk);
--		end loop;
--		-- rest of the cores do nothing, just say they're finished with OPC_OUT
--		for i in 2 to 31 loop
--			mem_addr <= std_logic_vector(unsigned(MEM_CORE0) + i*16);
--			wait until rising_edge(uc3_clk);
--			mem_cs <= '0';
--			wait until rising_edge(uc3_clk);
--			mem_we <= '0';
--			mem_data <= inst_done;
--			wait until rising_edge(uc3_clk);
--			wait until rising_edge(uc3_clk);
--			mem_we <= '1';
--			wait until rising_edge(uc3_clk);
--			mem_cs <= '1';
--			wait until rising_edge(uc3_clk);		
--		end loop;
--
--		-- clock in programs for all cores
		for i in 0 to 31 loop
			if i=0 then
				for j in 0 to 0 loop
					mem_addr <= std_logic_vector(unsigned(MEM_CORE0) + j);
					wait until rising_edge(uc3_clk);
					mem_cs <= '0';
					wait until rising_edge(uc3_clk);
					mem_we <= '0';
					mem_data <= core0_prg(j);
					wait until rising_edge(uc3_clk);
					wait until rising_edge(uc3_clk);
					mem_we <= '1';
					wait until rising_edge(uc3_clk);
					mem_cs <= '1';
					wait until rising_edge(uc3_clk);
					mem_data <= (others => 'Z');
				end loop;
				
			elsif i=8 then
				for j in 0 to 0 loop
					mem_addr <= std_logic_vector(unsigned(MEM_CORE8) + j);
					wait until rising_edge(uc3_clk);
					mem_cs <= '0';
					wait until rising_edge(uc3_clk);
					mem_we <= '0';
					mem_data <= core8_prg(j);
					wait until rising_edge(uc3_clk);
					wait until rising_edge(uc3_clk);
					mem_we <= '1';
					wait until rising_edge(uc3_clk);
					mem_cs <= '1';
					wait until rising_edge(uc3_clk);
					mem_data <= (others => 'Z');
				end loop;

			elsif i=16 then
				for j in 0 to 0 loop
					mem_addr <= std_logic_vector(unsigned(MEM_CORE16) + j);
					wait until rising_edge(uc3_clk);
					mem_cs <= '0';
					wait until rising_edge(uc3_clk);
					mem_we <= '0';
					mem_data <= core16_prg(j);
					wait until rising_edge(uc3_clk);
					wait until rising_edge(uc3_clk);
					mem_we <= '1';
					wait until rising_edge(uc3_clk);
					mem_cs <= '1';
					wait until rising_edge(uc3_clk);
					mem_data <= (others => 'Z');
				end loop;
				
			elsif i=24 then
				for j in 0 to 0 loop
					mem_addr <= std_logic_vector(unsigned(MEM_CORE24) + j);
					wait until rising_edge(uc3_clk);
					mem_cs <= '0';
					wait until rising_edge(uc3_clk);
					mem_we <= '0';
					mem_data <= core24_prg(j);
					wait until rising_edge(uc3_clk);
					wait until rising_edge(uc3_clk);
					mem_we <= '1';
					wait until rising_edge(uc3_clk);
					mem_cs <= '1';
					wait until rising_edge(uc3_clk);
					mem_data <= (others => 'Z');
				end loop;
			else
				mem_addr <= std_logic_vector(unsigned(MEM_CORE0) + i*16);
				wait until rising_edge(uc3_clk);
				mem_cs <= '0';
				wait until rising_edge(uc3_clk);
				mem_we <= '0';
				mem_data <= std_logic_vector'(OPC_OUT&"000000"&OPC_IN&std_logic_vector(to_unsigned(i, 6)));
				wait until rising_edge(uc3_clk);
				wait until rising_edge(uc3_clk);
				mem_we <= '1';
				wait until rising_edge(uc3_clk);
				mem_cs <= '1';
				wait until rising_edge(uc3_clk);				
				mem_data <= (others => 'Z');
			end if;
		end loop;
		
		--clock in the initial configuration before starting the evolution
		for i in 0 to 7 loop
			mem_addr <= std_logic_vector(unsigned(std_logic_vector'("00"&CONF_WORDS_BASE)) + i);
			wait until rising_edge(uc3_clk);
			mem_cs <= '0';
			wait until rising_edge(uc3_clk);
			mem_we <= '0';
			mem_data <= conf0(15 + 16*i downto 16 * i);
			wait until rising_edge(uc3_clk);
			wait until rising_edge(uc3_clk);
			mem_we <= '1';
			wait until rising_edge(uc3_clk);
			mem_cs <= '1';
			wait until rising_edge(uc3_clk);
			mem_data <= (others => 'Z');
		end loop;
		
		-- conf evo command
		where <= "RUN_EVO ";
		mem_addr <= "00"&CMD_REG;
		wait until rising_edge(uc3_clk);
		mem_cs <= '0';
		wait until rising_edge(uc3_clk);
		mem_we <= '0';
		mem_data <= CMD_CONF_EVO;
		wait until rising_edge(uc3_clk);
		wait until rising_edge(uc3_clk);
		mem_we <= '1';
		wait until rising_edge(uc3_clk);
		mem_cs <= '1';
		wait until rising_edge(uc3_clk);
		mem_data <= (others => 'Z');
		
		--mem_addr <= "00"&CMD_REG;
		--wait until rising_edge(uc3_clk);
		--mem_cs <= '0';
		--wait until rising_edge(uc3_clk);
		--mem_we <= '0';
		--mem_data <= "1000000000000000";
		--wait until rising_edge(uc3_clk);
		--wait until rising_edge(uc3_clk);
		--mem_we <= '1';
		--wait until rising_edge(uc3_clk);
		--mem_cs <= '1';
		--wait until rising_edge(uc3_clk);

		-- read initial config
		for i in 0 to 7 loop
			mem_addr <= std_logic_vector(unsigned(std_logic_vector'("00"&CONF_WORDS_BASE)) + i);
			wait until rising_edge(uc3_clk);
			mem_cs <= '0';
			wait until rising_edge(uc3_clk);
			mem_re <= '0';
			wait until rising_edge(uc3_clk);
			-- data should be put on bus here
			wait until rising_edge(uc3_clk);
			mem_re <= '1';
			wait until rising_edge(uc3_clk);
			mem_cs <= '1';
			wait until rising_edge(uc3_clk);
			mem_addr <= (others => '0');
		end loop;
		
		-- wait until finished processing
		where <= "WAITING ";
		while test = CMD_CONF_EVO loop
		mem_addr <= std_logic_vector(unsigned(std_logic_vector'("00"&CMD_REG)));
		wait until rising_edge(uc3_clk);
		mem_cs <= '0';
		wait until rising_edge(uc3_clk);
		mem_re <= '0';
		wait until rising_edge(uc3_clk);
		wait until rising_edge(uc3_clk);
		mem_re <= '1';
		test <= mem_data;
		wait until rising_edge(uc3_clk);
		mem_cs <= '1';
		wait until rising_edge(uc3_clk);
		mem_addr <= (others =>'0');
		end loop;
		where <= "READING ";
		for i in 0 to 2047 loop
			mem_addr <= std_logic_vector(unsigned(std_logic_vector'("100000000000")) + i);
			wait until rising_edge(uc3_clk);
			mem_cs <= '0';
			wait until rising_edge(uc3_clk);
			mem_re <= '0';
			wait until rising_edge(uc3_clk);
			-- data should be put on bus here
			wait until rising_edge(uc3_clk);
			mem_re <= '1';
			wait until rising_edge(uc3_clk);
			mem_cs <= '1';
			wait until rising_edge(uc3_clk);
			mem_addr <= (others => '0');
		end loop;
		where <= "PROGRAM ";
		for i in 0 to 15 loop
			mem_addr <= std_logic_vector(unsigned(std_logic_vector'(MEM_CORE5)) + i);
			wait until rising_edge(uc3_clk);
			mem_cs <= '0';
			wait until rising_edge(uc3_clk);
			mem_re <= '0';
			wait until rising_edge(uc3_clk);
			-- data should be put on bus here
			wait until rising_edge(uc3_clk);
			mem_re <= '1';
			wait until rising_edge(uc3_clk);
			mem_cs <= '1';
			wait until rising_edge(uc3_clk);
			mem_addr <= (others => '0');
		end loop;
		where <= "DONE    ";
      wait;
   end process;

END;
