--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   18:55:58 02/10/2012
-- Design Name:   
-- Module Name:   /home/jonemil/projects/materio/src/fpga_code//uc_interface_test.vhd
-- Project Name:  EMB
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: uc_interface
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use work.cpu_package.all;
use work.emb.all;
use ieee.numeric_std.all;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY uc_interface_test IS
END uc_interface_test;
 
ARCHITECTURE behavior OF uc_interface_test IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT uc_interface
    PORT(
         clk : IN  std_logic;
         rst : IN  std_logic;
         uc_addr : IN  std_logic_vector(11 downto 0);
         uc_data : INOUT  std_logic_vector(15 downto 0);
         uc_cs : IN  std_logic;
         uc_re : IN  std_logic;
         uc_we : IN  std_logic;
         uc_wait : OUT  std_logic;
         mem_we : OUT  std_logic;
         mem_addr : OUT  std_logic_vector(9 downto 0);
         mem_do : IN  std_logic_vector(15 downto 0);
         mem_din : OUT  std_logic_vector(15 downto 0);
         ca_inst_addr : OUT  mem_w_address_a(0 to N_CORES - 1);
         ca_inst_data_i : OUT  mem_w_data_a(0 to N_CORES - 1);
         ca_inst_we : OUT  mem_w_enable_a(0 to N_CORES - 1);
         ca_inst_data_o : IN  mem_w_out_a(0 to N_CORES - 1);
         ca_state_addr : OUT  std_logic_vector(9 downto 0);
         ca_state_data_i : OUT  std_logic_vector(15 downto 0);
         ca_state_we : OUT  std_logic;
         ca_state_data_o : IN  std_logic_vector(15 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal rst : std_logic := '0';
   signal uc_addr : std_logic_vector(11 downto 0) := (others => '0');
   signal uc_cs : std_logic := '0';
   signal uc_re : std_logic := '0';
   signal uc_we : std_logic := '0';
   signal mem_do : std_logic_vector(15 downto 0) := (others => '0');
   signal ca_inst_data_o : mem_w_out_a(0 to N_CORES - 1);
   signal ca_state_data_o : std_logic_vector(15 downto 0) := (others => '0');

	--BiDirs
   signal uc_data : std_logic_vector(15 downto 0);

 	--Outputs
   signal uc_wait : std_logic;
   signal mem_we : std_logic;
   signal mem_addr : std_logic_vector(9 downto 0);
   signal mem_din : std_logic_vector(15 downto 0);
   signal ca_inst_addr : mem_w_address_a(0 to N_CORES - 1);
   signal ca_inst_data_i : mem_w_data_a(0 to N_CORES - 1);
   signal ca_inst_we : mem_w_enable_a(0 to N_CORES - 1);
   signal ca_state_addr : std_logic_vector(9 downto 0);
   signal ca_state_data_i : std_logic_vector(15 downto 0);
   signal ca_state_we : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: uc_interface PORT MAP (
          clk => clk,
          rst => rst,
          uc_addr => uc_addr,
          uc_data => uc_data,
          uc_cs => uc_cs,
          uc_re => uc_re,
          uc_we => uc_we,
          uc_wait => uc_wait,
          mem_we => mem_we,
          mem_addr => mem_addr,
          mem_do => mem_do,
          mem_din => mem_din,
          ca_inst_addr => ca_inst_addr,
          ca_inst_data_i => ca_inst_data_i,
          ca_inst_we => ca_inst_we,
          ca_inst_data_o => ca_inst_data_o,
          ca_state_addr => ca_state_addr,
          ca_state_data_i => ca_state_data_i,
          ca_state_we => ca_state_we,
          ca_state_data_o => ca_state_data_o
        );
	mem : entity work.config_mem port map(
			clk => clk,
			--port a
			a_we => mem_we,
			a_addr => mem_addr,
			a_do => mem_do,
			a_din => mem_din,
			-- port b
			b_we => '0',
			b_addr => (others => '0'),
			b_do => open,
			b_din => (others => '0')			
			);
   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin
		uc_addr <= (others => '0');
		uc_data <= (others => 'Z');
		rst <= '0';
		uc_we <= '1';
		uc_cs <= '1';
		uc_re <= '1';
		wait for clk_period;
		rst <= '1';
      -- hold reset state for 100 ns.
      wait until rising_edge(clk);	
		uc_addr <= (others => '0');
		uc_re <= '0';
		uc_cs <= '0';
		wait until rising_edge(clk);
		uc_addr <= (10 => '1', others => '0');
		uc_re <= '0';
		uc_cs <= '0';
		wait until rising_edge(clk);
		uc_addr <= (11 => '1', others => '0');
		uc_re <= '0';
		uc_cs <= '0';
		wait until rising_edge(clk);
      -- insert stimulus here
		uc_re <= '1';
		uc_we <= '1';
		uc_cs <= '1';
		wait until rising_edge(clk);
		uc_addr <= (others => '0');
		uc_we <= '0';
		uc_cs <= '0';
		uc_data <= (1 => '1', 3 => '1', others => '0');
		wait until rising_edge(clk);
		uc_addr <= (others => '0');
		uc_cs <= '1';
		uc_we <= '1';
		uc_data <= (others => 'Z');
		wait until rising_edge(clk);
		uc_cs <= '0';
		uc_re <= '0';
		wait until rising_edge(clk);
		uc_addr <= (others => '0');
		uc_cs <= '1';
		uc_we <= '1';
		uc_data <= (others => 'Z');
      wait;
   end process;

END;
