library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.cpu_package.all;

entity writeback is
	port	(
		clk : in std_logic;
		rst : in std_logic;
		-- registered stuff from execute
		ex_alu_out_i : in std_logic_vector(DDATA_BUS - 1 downto 0);
		ex_r_out_i : in std_logic_vector(DDATA_BUS - 1 downto 0);
		ex_w_out_i : in std_logic_vector(DDATA_BUS - 1 downto 0);
		ex_push_i : in std_logic;
		ex_stop_i : in std_logic;
		ex_opc_i : in std_logic_vector(OPC_BUS - 1 downto 0);

		-- control signals to decode
		wb_opc_o : out std_logic_vector(OPC_BUS - 1 downto 0);

		-- to decode and executek
		wb_out_o : out std_logic_vector(DDATA_BUS - 1 downto 0);
		-- out of cpu
		stop_o : out std_logic;
		w_out_o : out std_logic_vector(DDATA_BUS - 1 downto 0) 
		);
end writeback;

architecture writeback_arch of writeback is
begin
w_out_o <= ex_w_out_i;
stop_o <= ex_stop_i;
wb_opc_o <= ex_opc_i;

-- Pass along data from in or alu
wb_out_o <= ex_r_out_i when ex_opc_i = OPC_IN else ex_alu_out_i;
end writeback_arch;
