#!/usr/bin/env python
from os.path import basename, splitext
import sys

def neighbourhood(core_num):
	sys.stderr.write('Error no neighbourhood defined.\n')
	sys.exit(1)

class program:
	def __init__(self, core_num, prog):
		self.instructions = prog
		self.core_num = core_num
	def add_inst(self, inst):
		self.instructions.append(inst)
	def rem_inst(self):
		return self.instructions.pop()
	def assemble(self):
		self.b_instructions = []
		for inst in self.instructions:
			self.b_instructions.append(inst.assemble(self.core_num))
		

class asm_instruction:
	def __init__(self, byte):
		self.byte = byte

	def assemble(self, core_num):
		return self.byte

class asm_in(asm_instruction):
	def __init__(self, pin):
		asm_instruction.__init__(self,1<<7)
		self.pin = pin
	def assemble(self, core_num):
		n = neighbourhood(core_num)
		return (self.byte|n[self.pin])

class asm_out(asm_instruction):
	def __init__(self):
		asm_instruction.__init__(self,1<<6)

class asm_xor(asm_instruction):
	def __init__(self):
		asm_instruction.__init__(self,11)
class asm_or(asm_instruction):
	def __init__(self):
		asm_instruction.__init__(self,10)

class asm_and(asm_instruction):
	def __init__(self):
		asm_instruction.__init__(self,9)

class asm_not(asm_instruction):
	def __init__(self):
		asm_instruction.__init__(self,1)

class asm_nop(asm_instruction):
	def __init__(self):
		asm_instruction.__init__(self,0)
		

def usage():
	sys.stderr.write('usage: ' + sys.argv[0] + ' [--<command>] <ca-assembly-file>\n')
	sys.stderr.write('\n')
	sys.stderr.write('commands:\n')
	sys.stderr.write('  help\n')
	sys.stderr.write('	shows help message\n')

def load(asmfile):
	global neighbourhood
	global ic
	file = open(asmfile, 'r')
	exec(file.read())
	neighbourhood = ne
	ic = initial_config
	file.close()
	return prog

def fwrite(fname, prog):
	file = open(fname, 'wb')
	s = ''
	for byte in prog.b_instructions:
		s = s + '%c' % (byte)
	#align if not even numbered number of instructions
	if (len(prog.b_instructions) % 2) != 0:
		s = s + '%c' % (0)

	file.write(s)
		
	file.close()

def main(argv):
	proglist = []
	fname = ''
	if len(argv) < 2:
		sys.stderr.write('error: missing command\n\n')
		usage()
		exit(1)

	if argv[1] == '--help':
		usage()
		exit(0)
	else:
		fname = splitext(basename(argv[1]))[0]
		prog = load(argv[1])
		for x in range(32):
			p = program(x, prog)
			p.assemble()
			proglist.append(p)
			fwrite('%s-%.2d.bin'%(fname,x), p)
		#write initial config in a file, basename.init
		file = open('%s.init'%(fname), 'wb')
		file.write(ic)
		file.close()
			
			
			
if __name__ == "__main__":
	main(sys.argv)
