#ifndef CA_STATE_H_
#define CA_STATE_H_ 1
#include <stdint.h>
#include <stdlib.h>

//Bit macros used for ca evo extension, created by Ole Henrik Jahren
#define BITS_ULONG (sizeof(uint8_t) * 8)
#define bit_count(x) (((x) + (BITS_ULONG - 1)) / BITS_ULONG)
#define bit_isset(array, bit) (((((array)[(bit) / BITS_ULONG]) & (1 << ((bit) % BITS_ULONG))) >> ((bit) % BITS_ULONG)) & 1)
#define BIT_DEFINE(array, bits) (unsigned long (array)[(bits)])
#define bit_get(array, bit) ((array)[(bit) / BITS_ULONG])
#define bit_set(array, bit) (bit_get(array, bit) |= (1 << ((bit) % BITS_ULONG)))
#define bit_clr(array, bit) (bit_get(array, bit) &= ~(1 << ((bit) % BITS_ULONG)))
#define bit_flip(array, bit) (bit_get(array, bit) ^= (1 << ((bit) % BITS_ULONG)))

#define NPINS 128

//pins have mode and value
typedef struct ca_pin {
	uint8_t mode;
	uint8_t value;
} ca_pin_t;
//const ca_pin_t z0 = {.mode=1, .value=0};

//the ca_state should containt 128 pins
typedef struct ca_states {
	size_t len;
	uint8_t* data;
} ca_states_t;
int write_states(const char* out_file, ca_states_t* states);
uint8_t *str_to_state(const char* string_state);
#endif
