#include <stdio.h>
#include <stdlib.h>
#include "ca_program.h"
#include "ca_state.h"
#include "datalink.h"
#include "emb.h"
#include "fpga_config.h"

int
main(int argc, char** argv)
{
	char * file_base;// = "../host/rule_90";
	char * out_file;// = "../../master_doc/experiments/rule_90.out";
	uint8_t *initial_state;// = "\xA0\xA0\xA0\xA0\xA0\xA0\xA0\xA0\x55\x55\x55\x55\x55\x55\x55\x55";
//	int response;
	/* initial state is 2 cores outputs 1, next 2 outputs 0, in an alternating pattern. The rest of the 32 pins is used for input only (0x5) */
	ca_states_t* states;
	ca_program_t** programs;

	if(argc < 2) {
		fprintf(stderr, "Usage:\n\t%s program\n", argv[0]);
		exit(1);
	}
	asprintf(&file_base, "../host/%s", argv[1]);
	asprintf(&out_file, "../../master_doc/experiments/%s.out", argv[1]);

	if (setup_datalink() < 0 )
		exit(1);

/*	config_fpga("../fpga_code/EMB/toplevel.rbt", 40000);
	if((response = getResponse()) != RESP_OK) {
		fprintf(stderr, "ca_program_test failed with code %d\n", response);
		exit(1);
	}
*/
	programs = read_programs(file_base);
	initial_state = read_initial_state(file_base);

	/*for(i=0;i<32;i++) {
		fprintf(stdout,"%d\n",programs[i]->len);
	}*/

	states = evo_config(initial_state, programs);

	write_states(out_file, states);
	unsetup_datalink();
	return 0;
}
