#ifndef FPGA_MEM_H_
#define FPGA_MEM_H_
#include <stdint.h>
#include "command.h"
uint8_t fpga_mem_readb(uint16_t byte_offset);
void fpga_mem_writeb(uint16_t byte_offset, uint8_t data);
void fpga_mem_copyfrom(void *dest, uint16_t byte_offset, uint16_t nbytes);
void fpga_mem_copyto(uint16_t byte_offset, void *src, uint16_t nbytes);

static inline uint16_t
fpga_mem_readh(uint16_t offset)
{
	volatile uint16_t *ptr = (uint16_t *)FPGA_ADDR;
	return ptr[offset];
}

static inline void
fpga_mem_writeh(uint16_t offset, uint16_t data)
{
	volatile uint16_t *ptr = (uint16_t *)FPGA_ADDR;
	ptr[offset] = data;
}
#endif
